#pragma implementation "AltBtcb.h"
#include <AltBtcb.h>
#include <Fbin.h>

altFile::altFile(const char *n,const char *a,int mode,const Keydata &buf):
  btFile(n,mode,buf), altf(a,BTRDONLY,buf)
{ }

altFile::~altFile() { }

altFile &altFile::operator=(Keydata buf) {
  btFile::operator=(buf);
  altf = buf;
  return *this;
}

static int comparebuf(const Btcb *a,const Btcb *b) {
  int lena = a->len();
  int lenb = b->len();
  int len = (lena > lenb) ? lenb : lena;
  int rc = blkcmpr(a->lbuf(),b->lbuf(),len);
  if (rc == 0)
    rc = lena - lenb;
  return rc;
}

int altFile::read(const Keydata &k,btop op) {
  switch (op) {
  case BTREADGE:
  case BTREADGT:
  case BTREADF: {
    int rc1 = btFile::read(k,op);
    int rc2 = altf.read(k,op);
    if (rc1 == 0 && rc2 == 0) {
      if (comparebuf(this,&altf) < 0) 
	unpack(rbuf);
    }
    return rc1 ? rc2 : rc1;
  }
  default: {
    int rc = btFile::read(k,op);
    if (rc)
      rc = altf.read(k,op);
    return rc;
  }
  }
}

int altFile::next() {
  if (rdstate() == 0 && altf.rdstate() == 0) {
    int rc = comparebuf(this,&altf);
    if (comparebuf(this,&altf) < 0) {
      rc = Btcb::next();
      if (rc || comparebuf(this,&altf) > 0)
	altf.unpack(rbuf);
      else
	unpack(rbuf);
    }
    else {
      rc = altf.Btcb::next();
      if (rc || comparebuf(this,&altf) < 0)
	unpack(rbuf);
      else
	altf.unpack(rbuf);
    }
    return rc;
  }
  return rdstate() ? altf.next() : btFile::next();
}

altFile::operator int() const {
  int rc = rdstate();
  return rc ? altf.rdstate() : rc;
}
