#ifdef __GNUC__
#pragma implementation "btcb.hpp"
#endif
#include <stdlib.h>
#include "btcb.hpp"

Btcb::Btcb(const char *name,int mode,int len) {
  rlen = 0;
  b = 0;
  b = btopen(name,mode,len);
  if (b)
    rlen = len;
}

void Btcb::setrlen(int len) {
  rlen = 0;
  if (b)
    b = (BTCB *)realloc(b,sizeof *b - sizeof b->lbuf + len);
  else {
    b = (BTCB *)malloc(sizeof *b - sizeof b->lbuf + len);
    if (b) {
      b->msgident = 0;
      b->flags = 0;
      b->mid = 0;
      b->root = 0;
      b->klen = 0;
      b->op = 0;
    }
  }
  if (b) {
    b->rlen = len;
    rlen = len;
  }
}

Btcb::Btcb(int len) {
  b = 0;
  setrlen(len);
}

int Btcb::open(const char *name,int mode) {
  // NOTE, we can't use btopenf() since rlen may be too small
  if (b) {
    btclose(b);
    b = 0;
  }
  b = btopen(name,mode,rlen);
  return b->op;
}

int Btcb::close() { return (b && b->flags) ? btas(BTCLOSE) : 0; }

void Btcb::error(int code) {
  exit(code);
}

int Btcb::create(int len,int klen,short uid,short gid,short mode) {
  b->rlen = len;
  if (klen < 0)
    b->klen = len;
  else
    b->klen = klen;
  b->u.id.user = uid;
  b->u.id.group = gid;
  b->u.id.mode = mode;
  return btas(BTCREATE|DUPKEY);
}

int Btcb::link(int len,int klen,t_block root) {
  b->rlen = len;
  if (klen < 0)
    b->klen = len;
  else
    b->klen = klen;
  b->u.cache.node = root;
  return btas(BTLINK|DUPKEY);
}

int Btcb::write(int len,int klen) {
  b->rlen = len;
  if (klen < 0)
    b->klen = len;
  else
    b->klen = klen;
  return btas(BTWRITE|DUPKEY);
}

int Btcb::replace(int len,int klen) {
  b->rlen = len;
  if (klen < 0)
    b->klen = len;
  else
    b->klen = klen;
  return btas(BTREPLACE|DUPKEY);
}
