#include "Date.h"

// 23*m/9+d+4+(m<3?y--:y-2)+y/4-y/100+y/400

Date::Date(const mmddyy &d) {	/* calc day of century */
  int dyyr;
  int yy = d.yy;
  if (yy < 50)				/* cludge to handle > 2000 */
    yy += 100;
  dyyr = d.dd + ((d.mm * 275)/9)-30;	/* day of year conversion */
  if (d.mm > 2) {			/* handle leapyears */
	  dyyr--;
	  if (yy % 4)
		  dyyr--;
  }
  dayno = (dyyr+((long)(yy - 1)*1461)/4);	/* day of century */
}

mmddyy Date::mdy() const {	/* calc mmddyy from dayno */
  int mm,dd,yy;
  int dyyr; 
  int leapyear = 2;		/* not leapyear adj = 2 */
  yy = (dayno - dayno/1461 +364)/365;	/* calculate year */
  dyyr = dayno - ((long)(yy-1)*1461)/4;	/* day of year conversion */
  if (yy % 4 == 0)			/* is this a leapyear? */
	  leapyear = 1;			/* yes - reset adj to 1 */
  if (dyyr > 59 && (dyyr > 60 || leapyear == 2))
	  dyyr += leapyear;		/* correct for leapyear */
  mm = (269 + dyyr * 9) / 275;	/* calculate month */
  dd = dyyr + 30 - 275 * mm/9;	/* calc day of month */
  if (yy >99)				/* cludge for > 2000 */
	  yy -= 100;
  return mmddyy(mm,dd,yy);
}
