#include "Date.h"
#include <strings.h>
#include <time.h>

void Julday::mdy(tm &t) const {
  mmddyy mdy(operator mmddyy());
  long jday = *this - Julday(1,1,mdy.yy) + 1;
  t.tm_mon = mdy.mm - 1;
  t.tm_mday = mdy.dd;
  t.tm_sec = 0;
  t.tm_min = 0;
  t.tm_hour = 0;
  t.tm_wday = dayno % 7;
  t.tm_yday = (int)jday;
  t.tm_year = mdy.yy - 1900;	// compatible with unix
  t.tm_isdst = 0;
}

string Julday::pic(const char *mask) const {
  if (dayno == 0) return "";
  tm t;
  mdy(t);
  return tm_mask(&t,mask);
}

#ifdef TEST_MAIN
#include <stdio.h>

int main(int argc,char **argv) {
  for (int i = 1; i < argc; i += 2) {
    const char *mask = (i + 1 < argc) ? argv[i + 1] : "YYMMDD";
    printf("%s -> %s\n",argv[i],Julday(argv[i]).pic(mask).c_str());
  }
  return 0;
}
#endif
