#include "EditWin.h"
#include <string.h>

int EditWin::linebits() const {
  int row,col;
  getyx(row,col);
  char c = (*this)(row,col);	// memchr requires 'char' !
  const unsigned char *p =
    (unsigned char *)memchr(graphics,c,sizeof graphics);
  if (!p) return 0;
  return p - graphics;
}

void EditWin::linedel() {
		 		/*  up   dn   lt   rt  */	
  static char masktbl[DIR_NONE] = { 010, 002, 001, 004 };

  static Dir op_dir[DIR_NONE+1] = {
    DIR_DOWN, DIR_UP, DIR_RIGHT, DIR_LEFT, DIR_NONE
  };

  move(op_dir[last_dir]);	/* move to last position */
  int c = linebits();		/* bit value under cursor */
  addch(' '); move(DIR_LEFT);
  for (int new_dir = DIR_UP; new_dir < DIR_NONE; ++new_dir) {
    if ((new_dir != last_dir) && (c&masktbl[new_dir])) {  /* if we join */
      Dir opp = op_dir[new_dir];	/* compute opposite direction */
      move((Dir)new_dir);		/* move that direction */
      int n = linebits();
      if (n&masktbl[opp]) {	/* if neighbor joins */
	last_dir = DIR_NONE;
	break;
      }
      move(opp);		/* move back to try again */
    }
  }
}

void EditWin::linemove(Dir d) {
  static char dirtbl[DIR_NONE][DIR_NONE+1] = {
  /*  up    down  left  right none   lastdir */	/* dir */
    { 0x0a, 0x0a, 0x0c, 0x09, 0x00 },		/* up */
    { 0x0a, 0x0a, 0x06, 0x03, 0x00 },		/* down */
    { 0x03, 0x09, 0x05, 0x05, 0x00 },		/* left */
    { 0x06, 0x0c, 0x05, 0x05, 0x00 }		/* right */
  };
  int base = (linemode - 1) << 4;
  int c = graphics[dirtbl[d][last_dir] | linebits() | base];
  if (c == 0) c = ' ';
  addch(c);
  move(DIR_LEFT);
  last_dir = d;
}

const unsigned char EditWin::graphics[48] = {
  0,		ACS_DIAMOND,	ACS_CKBOARD,	ACS_URCORNER,
  ACS_DEGREE,	ACS_HLINE,	ACS_ULCORNER,	ACS_TTEE,
  ACS_PLMINUS,	ACS_LRCORNER,	ACS_VLINE,	ACS_RTEE,
  ACS_LLCORNER, ACS_BTEE,	ACS_LTEE,	ACS_PLUS,
  /* double lines */
  219,		222,		223,		187,
  221,		205,		201,		203,
  220,		188,		186,		185,
  200,		202,		204,		206,
  /* thick lines */
  0,		0,		0,		220,
  0,		220,		220,		220,
  0,		223,		222,		221,
  223,		223,		222,		219
};
