/*
 * $Log$
 */
#include <string.h>
#ifdef __GNUC__
#pragma implementation "Fcb.h"
#endif
#include <keyboard.h>
#include "Fcb.h"

Fcb::Fcb() {
  nlins = 0;
  last = 0;
  tlen = 0;
  tagh = 0;
  keyh = 0;
  tbl = 0;
  curline = 0;
}

void Fcb::lindup(short n) {
  if (nlins) {
    if (tbl) for (int i = 0; i < nlins; ++i)
      delete tbl[i];
    delete [] tbl;
    delete [] tagh;
    delete [] keyh;
    tlen = 0;
    tagh = 0;
    keyh = 0;
    tbl = 0;
  }
  if (nlins = n) {
    tlen = taglen();
    tagh = new Tag[nlins];
    keyh = new char[tlen * nlins];
    tbl = new bmsScreen *[nlins];
    for (int i = 0; i < nlins; ++i) {
      tbl[i] = liner(i);
      tagh[i] = 0;
    }
  }
  last = 0;
}

Fcb::~Fcb() {
  delete [] tbl;
  delete [] tagh;
  delete [] keyh;
}

void Fcb::fwd() {	// display next page of table
  if (tagh[nlins-1] || !tagh[0]) {
    puttbl(locate(tagh[nlins-1]));
  }
}

const char *Fcb::rdlin() {	// read current table line
  return locate(tagh[curline]);
}

void Fcb::rev() {	// display previous page of table
  locate(tagh[0]);
  const char *t = prev(nlins - 1);
  if (t == 0)
    disp();
  else
    puttbl(t);
}

void Fcb::disp() {	// display first page of table
  puttbl(first(0));
}

void Fcb::find() {
  tbl[curline]->update();
  puttbl(locate());
}

void Fcb::puttbl(Tag tag,short line) {
  char *keyp = keyh;
  for (; line < nlins; ++line) {
    if (tag == 0) break;
    tagh[line] = keyp;
    memcpy(keyp,tag,tlen);
    keyp += tlen;
    tbl[line]->show();
    tbl[line]->top();
    tag = next();	// read next record
  }
  if (line < nlins) for (last = line; line < nlins; ++line) {
    tagh[line] = 0;
    tbl[line]->hide();
  }
}

void Fcb::getfocus() {
  if (nlins) {
    if (curline > nlins) curline = nlins - 1;
    setfocus(tbl[curline]);
  }
  else
    setfocus(0);
}

void Fcb::key(int ky) {
  if (nlins == 0) {
    Karet::key(ky);
    return;
  }
  int prevline = curline;
  switch (ky) {
  case KEY_F(2):
    rev();
    break;
  case KEY_F(3):
    fwd();
    break;
  case KEY_F(5):
    find();
    curline = 0;
    break;
  case KEY_UP:
    if (--curline < 0) {
      rev();
      curline = nlins - 1;
    }
    break;
  case KEY_DOWN:
    if (++curline >= nlins) {
      fwd();
      curline = 1;
    }
    break;
  case KEY_HOME:
    curline = 0;
    break;
  default:
    Karet::key(ky);
    return;
  }
  while (curline && tagh[curline] == 0) --curline;
  tbl[curline]->curfld(tbl[prevline]->curfld());
  setfocus(tbl[curline]);
  return;
}

void Fcb::cmd(int c) {
  if (curline >= 0 && curline < nlins) {
    tbl[curline]->cmd(c);
    return;
  }
  Controller::cmd(c);
}
