#pragma implementation "FileOpen.h"
#include <ListBox.h>
#include <FileOpen.h>
#include <Btcb.h>
#include <keyboard.h>
#include <Screen.h>
#include <string.h>

FileOpen::FileOpen(const char *p,const string &def): PromptWin(p,def) {
  listbox = 0;
}

FileOpen::~FileOpen() {
}

void FileOpen::key(int ky) {
  if (ky == KEY_ENTER) {
    pat = get();
    list.clear();
    dirname = fill(pat);
    if (!list[1]) {
      PromptWin::key(ky);	// process the enter if unique filename
      return;
    }
    // select from list
    bmsListBox lb(pat.c_str(),list);
    lb.setparent(this);
    lb.setphys(Rect(2,2,12,40));
    setfocus(&lb);
    ky = lb.run();
    set(dirname + list[lb.get()]);
    return;
  }
  PromptWin::key(ky);
}

#include <UnixDir.h>
#include <sys/stat.h>
extern "C" char *dirname(char *);

string FileOpen::fill(string &pat) {
  struct stat st;
  if (pat.length() == 0)
    pat = '*';
  else if (stat(pat.c_str(),&st) == 0 && (st.st_mode & S_IFDIR))
    pat += "/*";
  string temp(pat);
  pathopt(&temp[0],pat.c_str());
  const char *wild = basename(temp.c_str());
  string dirname(::dirname(&temp[0]));
  UnixDir ff(dirname.length() ? dirname.c_str() : ".");
  if (dirname.length())
    dirname += '/';
  for (int rc = ff.first(); rc; rc = ff.next()) {
    if (match(ff.name(),wild))
      list + ff.name();
  }
  list.sort();
  return dirname;
}
