/*	This module assumes:
	1) At least 8 bits per char
	2) If 9 or more bits per char:
	   a) signed characters (for sign extension)
	   b) signed shift right
*/

#include <money.hpp>
#include <string.h>
extern "C" {
#include <ftype.h>
}

Money::Money(const char *p,int len) {
// convert from file format to machine MONEY
  char buf[6];
  if (len > sizeof buf)
    p += (len - sizeof buf);
  else if (len < sizeof buf) {
    int i;
    if ((unsigned char)p[0] == 0x80) {
      for (i = 1; i < len && !p[i]; ++i)
	;
      if (i == len) {
	high = null.high;
	low = null.low;
	return;
      }
    }
    i = 6 - len;
    memcpy(buf + i,p,len);
    memset(buf,(*p & 0x80) ? ~0 : 0, i);
    p = buf;
  }
  high = ldlong(p);
  low  = ldshort(p+4);
}

void Money::store(char *p,int len) const {
// convert MONEY from memory to file format
  char buf[6];
  stlong(high,buf);
  stshort(low,buf+4);
  if (len > sizeof buf) {
    memset(p,(*buf & 0x80) ? ~0 : 0,len - sizeof buf);
    p += len - sizeof buf;
    len = sizeof buf;
  }
  memcpy(p,buf + 6 - len,len);
}
