#pragma implementation "Money.h"
#include "Money.h"

#define WSIZ 16			/* bits in unsigned short */

MONEY &MONEY::operator +=(const MONEY &b) {
  long l = (long)low + b.low;
  low = (unsigned short)l;
  high += b.high + (l >> WSIZ);
  return *this;
}

MONEY &MONEY::operator -=(const MONEY &b) {
  long l = (long)low - b.low;
  low = (unsigned short)l;
  high -= b.high + (l < 0);
  return *this;
}

Money &Money::operator +=(const Money &b) {
  long l = (long)low + b.low;
  low = (unsigned short)l;
  high += b.high + (l >> WSIZ);
  return *this;
}

Money &Money::operator -=(const Money &b) {
  long l = (long)low - b.low;
  low = (unsigned short)l;
  high -= b.high + (l < 0);
  return *this;
}

Money &Money::mul(short mul,short add) {
  long l = (long)low * mul + add;
  low = (unsigned short)l;
  high = high * mul + (short)(l >> WSIZ);
  return *this;
}

/*
	A mathematical definition of remainder:
Dividend  divisor    Q * d   +  r = D
D = -203, d = 100,  -2 * 100 + -3 = -103
D = -203, d = -100,  2 * -100 + -3 = -103
D = 203, d = 100,    2 * 100 + 3 = 103
D = 203, d = -100,  -2 * -100 + 3 = 103

	We currently don't guarrantee results when div <= 0.
*/

int Money::div(short div) {
  char sign = 0;
  if (high < 0) {
    mul(-1);
    sign = 1;
  }
  unsigned long l = ((high%div)<<WSIZ)+low;
  low = l / div;
  high /= div;
  if (sign) {
    mul(-1);
    return -(int)(l%div);
  }
  return (int)(l%div);
}

Money::Money(long lval) {       /* convert long to MONEY */
  low = (unsigned short)lval;
  high = (short)(lval >> WSIZ);
}

Money::operator long() const {	/* convert MONEY to long */
  return (high << WSIZ) + low;
}

static MONEY nullM = { 0x80000000L, 0 };
const Money Money::null(nullM);
