#include <Curses.h>
#include <Frame.h>
#include <keyboard.h>
#pragma implementation "overlay.cc"

struct clipBoard: Controller, CursesWin, FrameWin {
  clipBoard(short r,short c): CursesWin(r,c),FrameWin("Clipboard") {
    setfocus(this);
  }
  void key(int k);
private:
  clipBoard(const clipBoard &);
};

void clipBoard::key(int k) {
  switch (k) {
  case KEY_F(1):
    setfocus(0); return;
#if 0
  case KEY_UP: case 'k':
    setphys(loc + Point(-1,0)); return;
  case KEY_DOWN: case 'j':
    setphys(loc + Point(1,0)); return;
  case KEY_LEFT: case 'h':
    setphys(loc + Point(0,-1)); return;
  case KEY_RIGHT: case 'l':
    setphys(loc + Point(0,1)); return;
#endif
  }
  Controller::key(k);
}

CursesWin *CursesWin::copy(const Rect &r) const {
  Rect r1(r.intersect(Rect(0,0,rows-1,cols-1)));
  if (r1.isempty()) return 0;
#if 1
  CursesWin *w = new clipBoard(r1.height(),r1.width());
#else
  CursesWin *w = new CursesWin(r1.height(),r1.width());
#endif
  w->attr = A_REVERSE;
  w->curtype(0);
  for (int row = r1.r1; row <= r1.r2; ++row) {
    for (int col = r1.c1; col <= r1.c2; ++col) {
      w->addch((*this)(row,col));
    }
  }
  return w;
}

void CursesWin::overlay(const CursesWin *w) {
  Rect r(Rect(0,0,w->rows-1,w->cols-1) + Point(crow,ccol));
  Rect r1(r.intersect(Rect(0,0,rows-1,cols-1)));
  for (int row = r1.r1; row <= r1.r2; ++row) {
    move(row,col);
    for (int col = r1.c1; col <= r1.c2; ++col) {
      addch((*w)(row - r1.r1,col - r1.c1));
    }
  }
  move(r1.r1,r1.c1);
  sync();
}
