#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <fcntl.h>
#include <errno.h>
#include <signal.h>
#include "pidlock.h"

int PidLock::lock(string name) {
  unlock();
  char pid[13];
  int fd, rc;
  for (;;) {
    fd = open(name.c_str(),O_WRONLY+O_CREAT+O_EXCL,0444);
    if (fd >= 0) break;
    if (errno == EEXIST) {
      fd = open(name.c_str(),O_RDONLY);
      if (fd < 0) {
	if (errno == ENOENT) continue;
      }
      else if ((rc = read(fd,pid,sizeof pid - 1)) > 0) {
	pid[rc] = 0;
	int pidno = atoi(pid);
	if (kill(pidno,0) && errno == ESRCH) {
	  if (unlink(name.c_str()) == 0) {
	    /* fputs("Removing stale lock\n",stderr); */
	    continue;
	  }
	}
	if (pidno == 0) pidno = -1;
	return pidno;
      }
    }
    /* perror(name.c_str()); */
    return -1;
  }
  sprintf(pid,"%10d\n",getpid());
  rc = write(fd,pid,11);
  close(fd);
  if (rc != 11) {
    unlink(name.c_str());
    return -1;
  }
  chown(name.c_str(),getuid(),getgid());
  fname = name;
  return 0;
}

void PidLock::unlock() {
  if (fname.length()) {
    char pid[13];
    int fd, rc;
    fd = open(fname.c_str(),O_RDONLY);
    if (fd >= 0) {
      if ((rc = read(fd,pid,sizeof pid - 1)) > 0) {
	pid[rc] = 0;
	close(fd);
	if (atoi(pid) != getpid()) goto done;
      }
      close(fd);
      unlink(fname.c_str());
    }
  done:
    fname = "";
  }
}
