//#include <stdio.h>
#include <Browse.h>
#include "virtpos.h"

class Notifier: public PromptLine, Controller {
  Notifier(const Notifier &);
  const char *msg[2];
public:
  Notifier(const char *s,int r): PromptLine(msg) {
    msg[0] = s; msg[1] = 0;
    setfocus(this);
    setphys(Rect(r,0,r,loc.c2));
    run();
  }
  void key(int k) {
    setfocus(0);
  }
};

extern "C" int match(const char *,const char *);

void TextBrowser::search(const char *p) {
  int r = row + topline;
  string pat(1,'*');
  if (*p == '^')
    pat = ++p;
  else
    pat += p;
  if (pat[pat.length()-1] == '$')
    pat.erase((int)pat.length()-1,1);
  else
    pat += '*';
  const char *patptr = pat.c_str();
  //fprintf(stderr,"search::pat = %s\n",patptr);
  const char *s = txt[r];
  if (s) {
    int start = virtpos(s).mappos(col + leftcol);
    if (s[start]) ++start;
    s += start;
    do {
      int c;
      //fprintf(stderr,"search::str = %s\n",s);
      if (c = match(s,patptr)) {
	if (r > row + topline)
	  start = 0;
	move(r,virtpos(s - start).mapidx(--c + start));
	return;
      }
    } while (s = txt[++r]);
  }
  Notifier n("Search string not found",screen.r2);
}
