#include "Money.h"
#include <string.h>

#define find(a,b)	strchr(b,a)

Money::Money(const char *txt,const char *mask,int fix) {
  char *cp;
  const char *mp;
  int decpt = 0;
  int sign = 1;
  char legal[20];

  high = low = 0;
	
/* find fix from mask if zero */

  if (fix == 0) {
    mp = mask;
    while (*mp) {
      if (*mp++ == '.') decpt = 1;
      else if (decpt && find(mp[-1],"zZ#")) fix++;
    }
  }

/* build legal from mask.  Ignore "zZ#.+". */
  cp = legal; mp = mask;
  while (*mp) {
    if (!find(*mp++, "zZ#.+"))
      *cp++ = mp[-1];
  }
  *cp = '\0';

/* Convert number, ignoring all characters in mask except "zZ#.+-".  
   If "." found, set decpt.  If non-mask character found, terminate
   scan.  Ignore leading blanks.					*/

  /* skip leading blanks */
  while (*txt++ == ' ');
  txt--; 			/* correct overshoot */

  /* check for "-" in first non-blank position */
  if (*txt == '-') {
    sign = -1; 
    txt++;
  }

/* scan until separator encountered */
  decpt = 0;
  while ((*txt) && (fix >= 0)) {
    if (*txt == '.') decpt = 1;
    else if ((*txt >= '0') && (*txt <= '9')) {
      if (decpt && ((fix--) <= 0)) break;
      mul(10,*txt-'0');
    }
    else if (!find(*txt,legal)) break;

    txt++;
  }

  /* check for "-" in last position */
  if (*(txt-1) == '-') sign = -1;

  /* adjust sign */
  mul(sign);

  /* adjust fix */
  while (fix > 0) {
    mul(10);
    fix--;
  }
}
