#include <strutil.h>
#include <ctype.h>

/** These functions have no counterpart in STL. */
void gsub(string &s,const string &pat,const string &rep) {
  size_t len = rep.length();
  size_t patlen = pat.length();
  for (size_t pos = 0;;pos += len) {
    pos = s.find(pat,pos);
    if (pos == s.npos) break;
    s.replace(pos,patlen,rep);
  }
}

void gsub(string &s,char c,char r) {
  for (size_t pos = 0;;++pos) {
    pos = s.find(c,pos);
    if (pos == s.npos) break;
    s[pos] = c;
  }
}

int split(const string &s,vector<string> &v,int n,const string &sep) {
  v.clear();
  size_t len = sep.length();
  size_t beg = 0;
  while (v.size() < n) {
    size_t pos = s.find(sep,beg);
    if (pos == s.npos) break;
    v.push_back(s.substr(beg,pos - beg));
    beg = pos + len;
  }
  v.push_back(s.substr(beg));
  return v.size();
}

int split(const string &s,vector<string> &v,int n,char sep) {
  v.clear();
  size_t beg = 0;
  while (v.size() < n) {
    size_t pos = s.find(sep,beg);
    if (pos == s.npos) break;
    v.push_back(s.substr(beg,pos - beg));
    beg = pos + 1;
  }
  v.push_back(s.substr(beg));
  return v.size();
}

string downcase(const string &s) {
  string r(s);
  for (string::iterator p = r.begin(); p != r.end(); ++p) {
    if (isupper(*p))
      *p = tolower(*p);
  }
  return r;
}

string upcase(const string &s) {
  string r(s);
  for (string::iterator p = r.begin(); p != r.end(); ++p) {
    if (islower(*p))
      *p = toupper(*p);
  }
  return r;
}
