// Return System file data
#pragma implementation
#include <string>
#include <algorithm>
#include "sysdata.h"

SystemData::SystemData(const char *name): sysf(Keydata(&rec,sizeof rec)) {
  if (!name) name = "BMS/SYSTEM.DATA";
  sysf.open(name,BTRDONLY);
}

int SystemData::lookup(const char *name) {
  ECHAR<8> key = name;
  if (rec.name != name && sysf.readeq(&key))
    return 0;
  return ebcdic(rec.type);
}

long SystemData::getval(const char *name) {
  switch (lookup(name)) {
  case 'W':	return ldshort(rec.data);
  case 'D':	return ldlong(rec.data);
  }
  return -1L;
}

string SystemData::operator[](const char *name) {
  char str[64];
  switch (lookup(name)) {
  case 'W': case 'D':
    return dec(getval(name));
  case 'C':
    ldebstr(str,(unsigned char *)rec.data,rec.len);
    return str;
  }
  return "";
}

SystemData::~SystemData() {}
